<?php

/*
Plugin Name: Google Real Estate Maps
Plugin URI: http://realestate.ai/blog/43/google-real-estate-maps-wordpress-plugin/
Description: Creates and inserts Google real estate maps into pages and posts. Visit the <a href="tools.php?page=google-real-estate-map">settings page</a> to get started. 
Version: 1.0
Author: RealEstate.ai
Author URI: http://realestate.ai/
*/


add_shortcode('real_estate_map', 'real_estate_map');
function real_estate_map($atts){
$pluginpath = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));    	
extract(shortcode_atts(array(
'id' => '1'
), $atts));
global $wpdb;
$google_real_estate_map_configs = $wpdb->prefix . "google_real_estate_map";
$maplist = $wpdb->get_results("SELECT * FROM $google_real_estate_map_configs WHERE id = '$id'");
foreach ($maplist as $maps){
$city = strtolower(str_replace(" ","+",$maps->city));
$width = str_replace("px","",$maps->width);
$height = str_replace("px","",$maps->height);
$linkback = $maps->backlink;



switch ($maps->state)
{
case AL: $smstate ="Alabama"; break; 
case AK: $smstate ="Alaska"; break; 
case AZ: $smstate ="Arizona"; break; 
case AR: $smstate ="Arkansas"; break; 
case CA: $smstate ="California"; break; 
case CO: $smstate ="Colorado"; break; 
case CT: $smstate ="Connecticut"; break; 
case DE: $smstate ="Delaware"; break; 
case DC: $smstate ="District Of Columbia"; break; 
case FL: $smstate ="Florida"; break; 
case GA: $smstate ="Georgia"; break; 
case HI: $smstate ="Hawaii"; break; 
case ID: $smstate ="Idaho"; break; 
case IL: $smstate ="Illinois"; break; 
case IN: $smstate ="Indiana"; break; 
case IA: $smstate ="Iowa"; break; 
case KS: $smstate ="Kansas"; break; 
case KY: $smstate ="Kentucky"; break; 
case LA: $smstate ="Louisiana"; break; 
case ME: $smstate ="Maine"; break; 
case MD: $smstate ="Maryland"; break; 
case MA: $smstate ="Massachusetts"; break; 
case MI: $smstate ="Michigan"; break; 
case MN: $smstate ="Minnesota"; break; 
case MS: $smstate ="Mississippi"; break; 
case MO: $smstate ="Missouri"; break; 
case MT: $smstate ="Montana"; break; 
case NE: $smstate ="Nebraska"; break; 
case NV: $smstate ="Nevada"; break; 
case NH: $smstate ="New Hampshire"; break; 
case NJ: $smstate ="New Jersey"; break; 
case NM: $smstate ="New Mexico"; break; 
case NY: $smstate ="New York"; break; 
case NC: $smstate ="North Carolina"; break; 
case ND: $smstate ="North Dakota"; break; 
case OH: $smstate ="Ohio"; break; 
case OK: $smstate ="Oklahoma"; break; 
case Oregon: $smstate ="Oregon"; break; 
case PA: $smstate ="Pennsylvania"; break; 
case RI: $smstate ="Rhode Island"; break; 
case SC: $smstate ="South Carolina"; break; 
case SD: $smstate ="South Dakota"; break; 
case TN: $smstate ="Tennessee"; break; 
case TX: $smstate ="Texas"; break; 
case UT: $smstate ="Utah"; break; 
case VT: $smstate ="Vermont"; break; 
case VA: $smstate ="Virginia"; break; 
case WA: $smstate ="Washington"; break; 
case WV: $smstate ="West Virginia"; break; 
case WI: $smstate ="Wisconsin"; break; 
case WY: $smstate ="Wyoming"; break;
default:
  echo "No number between 1 and 3";
}
$state = strtolower(str_replace(" ","+",$smstate));
if($maps->state == "Oregon"){
$linkstate = "or";
}
else{
$linkstate = strtolower($maps->state);
}
$linkcity = strtolower(str_replace(" ","-",$maps->city));

$body .= '<p><iframe width="'; if($width==0){$body .= '95%"'; }else{$body .= $width.'px"';} $body .=' scrolling="no" height="'; if($height==0){$body .= '400px"';}else{$body .= $height.'px"'; } $body .=' frameborder="0" src="http://maps.google.com/maps?f=q&amp;source=s_q&amp;hl=en&amp;geocode=&amp;q=real+estate+'.$city.'+'.$state.'&amp;ie=UTF8&amp;hq=real+estate&amp;hnear='.$city.'+'.$state.'&amp;t=h&amp;z=10&amp;output=embed" marginwidth="0" marginheight="0"></iframe><br>'; if($linkback!=0){$body .= '<small><a style="text-align: left;margin:0px;" href="http://realestate.ai/'.$linkcity.'-'.$linkstate.'">More '.$maps->city.' Real Estate Information</a></small>';} $body .='</p>';
return "$body";
}
}



add_action('admin_menu', 'google_real_estate_map_menu');

function google_real_estate_map_menu() {

 add_submenu_page( 'tools.php', 'Google Real Estate Map', 'Google Real Estate Map', 'manage_options', 'google-real-estate-map', 'google_real_estate_map_options');

}

function google_real_estate_map_options() {
$pluginpath = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
  if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
  }
echo "<script type='text/javascript' src='".$pluginpath."js/tooltip.js'></script>";
?>

<div class="wrap">
<h1>Google Real Estate Maps</h1>
<?php 
if($_GET['delete']){	
global $wpdb;
$google_real_estate_map_configs = $wpdb->prefix."google_real_estate_map";
$delete = $wpdb->query("DELETE FROM $google_real_estate_map_configs WHERE id = '$_GET[delete]'");
}
if($_POST){
global $wpdb;
$google_real_estate_map_configs = $wpdb->prefix."google_real_estate_map";
$sql = $wpdb->prepare("INSERT INTO $google_real_estate_map_configs (`city` , `state` , `height` , `width` , `backlink`)VALUES ('".$_POST[city]."', '".$_POST[state]."', '".$_POST[height]."', '".$_POST[width]."', '".$_POST[linkback]."');");
$wpdb->query($sql);
$id = $wpdb->insert_id;
?>
<div class="updated fade" id="message"><p> <?php $wpdb->print_error(); ?> <br/><strong>Your new real estate map settings have been saved.</strong></p>
<p>To install your map paste the following code in the page or post you wish the map to appear.</p>
<p>
<strong>INSTALL CODE:</strong><br/><br/>
[real_estate_map id=<?php echo $id; ?>]
</p>
</div>
<?php } 
if($delete){ ?><div class="updated fade" id="message"><p><strong>Your map has been deleted.</strong></p></div>
<?php }

?>

<div id="poststuff" class="metabox-holder has-right-sidebar">
<?php include('admin-sidebar.php'); ?>
<div class="has-sidebar sm-padded" >
<div id="post-body-content" class="has-sidebar-content">
<div class="meta-box-sortabless">
<div id="sm_rebuild" class="postbox">
<h3 style="cursor:default;" ><span>Create A New Map:</span></h3>
<div class="inside">
<form id="add-new" method="post" action="" >
<table>
	<tr colspan"2">
		<td align="right">
			City:
		</td>
		<td>
			<input type="text" name="city" /><a onmouseover="Tip('Enter a city for this map to focus on.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a>
		</td>
		<td align="right">
			State:
		</td>
		<td>
<select name="state"> 
<option value="" selected="selected">Select a State</option> 
<option value="AL">Alabama</option> 
<option value="AK">Alaska</option> 
<option value="AZ">Arizona</option> 
<option value="AR">Arkansas</option> 
<option value="CA">California</option> 
<option value="CO">Colorado</option> 
<option value="CT">Connecticut</option> 
<option value="DE">Delaware</option> 
<option value="DC">District Of Columbia</option> 
<option value="FL">Florida</option> 
<option value="GA">Georgia</option> 
<option value="HI">Hawaii</option> 
<option value="ID">Idaho</option> 
<option value="IL">Illinois</option> 
<option value="IN">Indiana</option> 
<option value="IA">Iowa</option> 
<option value="KS">Kansas</option> 
<option value="KY">Kentucky</option> 
<option value="LA">Louisiana</option> 
<option value="ME">Maine</option> 
<option value="MD">Maryland</option> 
<option value="MA">Massachusetts</option> 
<option value="MI">Michigan</option> 
<option value="MN">Minnesota</option> 
<option value="MS">Mississippi</option> 
<option value="MO">Missouri</option> 
<option value="MT">Montana</option> 
<option value="NE">Nebraska</option> 
<option value="NV">Nevada</option> 
<option value="NH">New Hampshire</option> 
<option value="NJ">New Jersey</option> 
<option value="NM">New Mexico</option> 
<option value="NY">New York</option> 
<option value="NC">North Carolina</option> 
<option value="ND">North Dakota</option> 
<option value="OH">Ohio</option> 
<option value="OK">Oklahoma</option> 
<option value="Oregon">Oregon</option> 
<option value="PA">Pennsylvania</option> 
<option value="RI">Rhode Island</option> 
<option value="SC">South Carolina</option> 
<option value="SD">South Dakota</option> 
<option value="TN">Tennessee</option> 
<option value="TX">Texas</option> 
<option value="UT">Utah</option> 
<option value="VT">Vermont</option> 
<option value="VA">Virginia</option> 
<option value="WA">Washington</option> 
<option value="WV">West Virginia</option> 
<option value="WI">Wisconsin</option> 
<option value="WY">Wyoming</option>
</select>
<a onmouseover="Tip('Please select a state for your map to focus on.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a>
		</td>
	</tr>
	<tr colspan"2">
			<td style="padding-top:10px;" align="right">
			Width:
		</td>
		<td style="padding-top:10px;" >
			<input type="text" name="width" />
			<a onmouseover="Tip('Please select a width in pixels for your map. If you are unsure about this, leave it blank and we will size your map to fit in your page or post.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a>
		</td>
		<td style="padding-top:10px;" align="right">
			Height:
		</td>
		<td style="padding-top:10px;" >
			<input type="text" name="height" />
			<a onmouseover="Tip('Please select a height in pixels for your map. If you are unsure about this, leave it blank and we will assign a default height of 400px.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a>
		</td>
	</tr>
</table>
<input type="checkbox" checked name="linkback" value="1" /> Enable a backlink to the plugin autor's site.<a onmouseover="Tip('We build and provide free tools and services (like this plugin) for the real estate industry. All we ask in return is that you help us out a bit by allowing us to put a small link below the map. However, if you are not sure or feel uncomfortable linking to us, we can totally understand.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a>

<p style="margin: 5px; padding: 0pt;" class="submit">
<input type="submit" class="button-primary" value="SAVE THIS MAP" />
</p>

</form>
</div>
</div>
<div id="sm_rebuild" class="postbox">
	<h3 style="cursor:default;"><span>Your Saved Maps</span></h3>
		<div class="inside">


<div style="margin:10px;">
<table cellspacing="10" border="0">
<tr>
<td><strong>City</strong></td>
<td><strong>State</strong></td>
<td><strong>Install Code</strong><a onmouseover="Tip('Copy the codes below and paste into the pages and post that you would like your map to appear.', WIDTH, 250, ABOVE, true, OFFSETX, 1, FADEIN, 400, FADEOUT, 300)" onmouseout="UnTip()"><img src="<?php echo $pluginpath; ?>img/help.png" /></a></td>
</tr>
<?php	
global $wpdb;
$google_real_estate_map_configs = $wpdb->prefix . "google_real_estate_map";
$maplist = $wpdb->get_results("SELECT * FROM $google_real_estate_map_configs");
foreach ($maplist as $maps){ 
	echo "<tr col=\"3\"><td>".$maps->city."</td><td>".$maps->state."</td><td>[real_estate_map id=".$maps->id."]</td><td><a style=\"color:red\" href=\"tools.php?page=google-real-estate-map&delete=".$maps->id."\">delete</a></td></tr>";

} 
?></table>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>

<?php
}



$google_real_estate_map_db_version = "1";

register_activation_hook(__FILE__,'realestate_map_install');
function realestate_map_install () {
	global $wpdb;
	global $google_real_estate_map_db_version;
	$google_real_estate_map = $wpdb->prefix . "google_real_estate_map";
   	if($wpdb->get_var("show tables like '$google_real_estate_map'") != $google_real_estate_map) {
	   	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');  
		$configs_sql = "CREATE TABLE `".$google_real_estate_map."` (
		`id` INT( 255 ) NOT NULL AUTO_INCREMENT ,
		`city` VARCHAR( 500 ) NOT NULL ,
		`state` VARCHAR( 500 ) NOT NULL ,
		`width` INT( 5 ) NOT NULL DEFAULT '0' ,
		`height` INT( 5 ) NOT NULL DEFAULT '0' ,
		`backlink` INT( 1 ) NOT NULL DEFAULT '0' ,
		UNIQUE KEY id (id)
		);";
	dbDelta($configs_sql);
	}
}
 
?>